module.exports = function (grunt) {
  grunt.initConfig({
    includes: {
      js: {
        options: {
          includeRegexp: /include\(+['"]?([^'"]+)['"]?\)*$/
        },
        files: [
          {
            src: ['websy-qlik-object-manager.js'],
            dest: 'temp/',
            cwd: 'src/js'
          }
        ]        
      }
    },    
    eslint: {
      target: ['src/**/*.js'],
      options: {
        configFile: '.eslintrc'
      }
    },
    watch: {
      clientscript: {
        files: ['src/**/*.js'], // which files to watch
        tasks: ['includes', 'eslint', 'babel', 'uglify', 'copy'],
        options: {
          nospawn: true,
          livereload: true
        }
      }      
    },
    babel: {
      options: {
        sourceMap: false,
        presets: ['@babel/preset-env'],
        plugins: ['@babel/plugin-transform-object-assign', '@babel/plugin-transform-async-to-generator']  		
      },						
      dist: {
        files: [
          {
            'dist/websy-qlik-object-manager-light.js': 'temp/websy-qlik-object-manager.js'
          }
        ]
      }
    },
    uglify: {
      options: {
        beautify: false,
        mangle: true,
        compress: true
      },
      build: {
        files: [
          {
            'dist/websy-qlik-object-manager-light.min.js': ['dist/websy-qlik-object-manager-light.js']
          }
        ]
      }
    },
    copy: {
      main: {
        files: [
          {
            src: ['temp/websy-qlik-object-manager.js'],
            dest: 'dist/websy-qlik-object-manager-light.debug.js'
          },
          
        ]
      }
    }
  })
  grunt.loadNpmTasks('grunt-includes')
  grunt.loadNpmTasks('grunt-babel')
  grunt.loadNpmTasks('grunt-contrib-copy')
  grunt.loadNpmTasks('grunt-contrib-watch')
  grunt.loadNpmTasks('grunt-contrib-uglify')
  grunt.loadNpmTasks('grunt-express-server')
  grunt.loadNpmTasks('grunt-eslint')
  grunt.registerTask('default', ['includes', 'eslint', 'babel', 'uglify', 'copy', 'watch'])
  grunt.registerTask('build', ['includes', 'eslint', 'babel', 'uglify', 'copy'])  
}
